import { __extends } from 'tslib';
import React__default, { useEffect } from 'react';
import { HTMLProjectionNode } from '../../projection/node/HTMLProjectionNode.js';
import sync from 'framesync';
import 'popmotion';

var MeasureLayout = /** @class */ (function (_super) {
    __extends(MeasureLayout, _super);
    function MeasureLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * This only mounts projection nodes for components that
     * need measuring, we might want to do it for all components
     * in order to incorporate transforms
     */
    MeasureLayout.prototype.componentDidMount = function () {
        var visualElement = this.props.visualElement;
        var projection = visualElement.projection;
        projection.setOptions({
            onLayoutUpdate: function (_a) {
                var delta = _a.delta;
                console.log(delta.y);
                projection.setTargetDelta(delta);
            },
            onProjectionUpdate: function () {
                // visualElement.scheduleRender()
                sync.render(function () {
                    Object.assign(visualElement.getInstance().style, projection.getProjectionStyles());
                });
            },
        });
    };
    MeasureLayout.prototype.getSnapshotBeforeUpdate = function () {
        var _a;
        (_a = this.props.visualElement.projection) === null || _a === void 0 ? void 0 : _a.willUpdate();
        return null;
    };
    MeasureLayout.prototype.componentDidUpdate = function () {
        var _a;
        (_a = this.props.visualElement.projection) === null || _a === void 0 ? void 0 : _a.root.didUpdate();
    };
    MeasureLayout.prototype.render = function () {
        var _a;
        var visualElement = this.props.visualElement;
        if (!visualElement.projection) {
            console.log(this.props.id);
            var parent_1 = (_a = visualElement.parent) === null || _a === void 0 ? void 0 : _a.projection;
            visualElement.projection = new HTMLProjectionNode(parent_1);
        }
        return null;
    };
    return MeasureLayout;
}(React__default.Component));
var layoutFeatures = {
    measureLayout: MeasureLayout,
    layoutAnimation: function (_a) {
        var visualElement = _a.visualElement, layout = _a.layout, layoutId = _a.layoutId;
        visualElement.projection;
        useEffect(function () {
            if (!(layout || layoutId))
                return;
            // Add scale correction
            // Add layout update listener to trigger animation
            return function () {
                // Remove layout update listener
            };
        }, [layout, layoutId]);
        return null;
    },
};

export { layoutFeatures };
